
# This code is copyright Articulate Software (c) 2003.  
# This software is released under the GNU Public License <http://www.gnu.org/copyleft/gpl.html>.
# Users of this code also consent, by use of this code, to credit Articulate Software
# in any writings, briefings, publications, presentations, or 
# other representations of any software which incorporates, builds on, or uses this 
# code.  

# Usage: perl convert.pl
# Assumptions: The program assumes that the 1.6-2.0 mappings are in ../mapping-16-20
# and that the SUMO-WordNet mappings files are in the current directory.
# Author: Adam Pease adampease at earthlink.net
# Date: December 17, 2003

# The WordNet 1.6-2.0 mappings are courtesy of Jordi Daud, Lluis Padr and German 
# Rigau, members of the Natural Language Research Group within TALP Research Center 
# for Language and Speech Technology and Applications of the UPC. The mappings are
# available at <http://www.lsi.upc.es/~nlp/tools/mapping.html>
        
&convert;

sub convert {                 # SUMO-WordNet-1.6 mappings to WordNet 2.0

   print "Starting\n";
   open(FILE,"../mapping-16-20/wn16-20.adv");
   @LINES1 = <FILE>;
   close(FILE);

   for ($linenum=0; $linenum<$#LINES1; $linenum=$linenum+1) {
      $LINES1[$linenum] =~ /^(\d+) (\d+) ([\d\.]+)/;
      $wn16 = $1;
      $wn20 = $2;
      $confidence = $3;
      if ($confidence != 1) {
         while ($LINES1[$linenum] =~ s/(\d+) ([\d\.]+)$// ) {
            $new20 = $1;
            $newconf = $2;
            if ($newconf > $confidence) {
               $confidence = $newconf;
               $wn20 = $new20;
            }
         }
      }
      $mappings{$wn20} = $wn16;    
   }
   
   print "Done reading 1.6-2.0 mappings.\n";

   open(FILE,"WordNetMappings-adv.txt");
   @LINES2 = <FILE>;
   close(FILE);

   for ($linenum=0; $linenum<$#LINES2; $linenum=$linenum+1) { 
      $LINES2[$linenum] =~ /^(\d+) (.*) \&\%(.*)/;
      $wn16 = $1;
      $body = $2;
      $mappings = $3;
      $SUMO{$wn16} = $mappings;
   }

   print "Done reading 1.6-SUMO mappings.\n";
   
   open(FILE,"adv.dat");
   @LINES3 = <FILE>;
   close(FILE);
   
   open(OUTFILE,">WordNetMappings2-adv.txt");
   for ($linenum=0; $linenum<$#LINES3; $linenum=$linenum+1) { 
      $LINES3[$linenum] =~ /^(\d+) (.*)/;
      $wn20ss = $1;
      $wn20rest = $2;
      $wn16ss = $mappings{$wn20ss};
      if ($SUMO{$wn16ss} =~ /.+/) {
         print OUTFILE $wn20ss . " " . $wn20rest . "&%" . $SUMO{$wn16ss} . "\n";
      }
      else {
         print OUTFILE $wn20ss . " " . $wn20rest . "\n";
      }

   }

   close(OUTFILE);
}
